#############################################################################
# Program Name - Sepal's Library v0.1                                       # 
# File Name - sp_lib.cgi                                                    #
# Date - 2000. 03. 30                                                       #
# Programer - Kim se youn                                                   #
# Why make it? ...  I am a lazybones (ö ³???  !!! ^.^)       #
#############################################################################

sub parseArgument {
    my($name,$value,$content_type,$content_length,$buffer,$dump,$boundary,$line,$array_value);
    my(@pairs,@column);

    if($ENV{'QUERY_STRING'}) {
    @pairs = split(/&/,$ENV{'QUERY_STRING'});

        foreach (@pairs) {
            ($name, $value) = split(/=/,$_);

            $value =~ tr/+/ /;
            $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
			$FORM{$name} = $value;
        } 
    }
    else {
        $content_type = $ENV{'CONTENT_TYPE'};
        $content_length = $ENV{'CONTENT_LENGTH'};

        binmode STDIN;
        read(STDIN,$buffer,$content_length);
 
        if((!$content_type) ||
           ($content_type eq 'application/x-www-form-urlencoded')) {
            @pairs = split(/&/, $buffer);

            foreach (@pairs)  {
                ($name, $value) = split(/=/,$_);
                $value =~ tr/+/ /;
                $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
				$FORM{$name} = $value;
            }
        }
        elsif($content_type =~ m#^multipart/form-data#) {
            ($boundary = $content_type) =~ s/^.*boundary=(.*)$/$1/;
            @pairs = split(/--$boundary/, $buffer);
            @pairs = splice(@pairs,1,$#pairs-1);

            foreach (@pairs)  {
                ($dump,$line,$value) = split(/\r\n/,$_,3);
                if($line =~ /filename/) {
	            $real_file = $line;
                }

                next if $line =~ /filename=\"\"/;
                $line =~ s/^Content-Disposition: form-data; //;
                (@column) = split(/;\s+/, $line);
                ($name = $column[0]) =~ s/^name="([^"]+)"$/$1/g;
			
				if($#column > 0) { 
                    if($value =~ /^Content-Type:/)  {
                        ($dump,$dump,$value) = split(/\r\n/,$value,3);
                    }
                    else {
                        ($dump,$value) = split(/\r\n/,$value,2);
                    }
                }
                else {
                    ($dump,$value) = split(/\r\n/,$value,2);
                    if(grep(/^$name$/, keys(%CGI))) {
                        if(@{$FORM{$name}} > 0) {
                            push(@{$FORM{$name}}, $value);
                        }
                        else { 
                            $array_value = $FORM{$name};
                            undef $FORM{$name};
                            $FORM{$name}[0] = $array_value;
                            push(@{$FORM{$name}}, $value);
                        }
                    }
                    else {
                        next if $value =~ /^\s*$/;
                        $FORM{$name} = $value;
                        chop($FORM{$name});
	                chop($FORM{$name});
                    }
                    next;
                }
				$FORM{$name} = $value;
			}	
        }
        else {
            print "Invalid content type!\n";
            exit(1);
        }
    }
	$main_dir = "$main_dir/$FORM{'id'}";
	$main_url = "$main_url/$FORM{'id'}";
}

#INPUT, TEXTAREA  Լ -------------------------------------------------------------

sub Input{
	my($type, $name, $value, $back_color, $solid_color, $size, $maxlength) = @_;
	$back_color = "" if($back_color eq "");
	$solid_color = "#043C66" if($solid_color eq "");
	my($name_val) = $name ? "name=$name" : '';
	my($value_val) = ($value ne "") ? "value=\"$value\"" : '';
	my($size_val) = $size ? "size=$size" : '';
	my($max_len) = $maxlength ? "maxlength=$maxlength" : '';
	my($input_style) = "style='background-color:;border:1 solid $solid_color;height:20'" if($type ne "hidden");
	return "<input type=$type $name_val $value_val $size_val $max_len $input_style class=text>\n";
}

sub Textarea{
	my($cols, $rows, $name, $back_color, $solid_color,$comment) = @_;
	my($textarea_style);
	$back_color = "" if($back_color eq "");
	$solid_color = "#043C66" if($solid_color eq "");
	$textarea_style = "style='background-color:;border:1 solid $solid_color'";
	return "<textarea cols=$cols rows=$rows name=$name $textarea_style class=content>$comment</textarea>\n";
}

sub Checkbox{
	my($name, $value, $check_val) = @_;
	$check_val = $check_val ? "checked" : "";
	return "<input type=checkbox name=$name value=$value $check_val>\n";
}

#̺  Լ---------------------------------------------------------------
sub Thead{
	my($width, $bgcolor, $cellpadding, $cellspacing) = @_;
	my($wid_val) = $width ? "width=$width" : '';
	my($bgcolor_val) = $bgcolor ? "bgcolor=$bgcolor" : '';
	print "<div align=center><table $wid_val border=0 $bgcolor_val cellpadding=$cellpadding cellspacing=$cellspacing>";
}

sub Tfoot{
	print "</table></div>\n";
}

#form  Լ ----------------------------------------------------------------
sub Fhead{
	my($method, $action, $enctype) = @_;
	my($enc_val) = $enctype ? "enctype=$enctype" : ''; 
	print "<form method=$method action=$action $enc_val>\n";
}

sub Ffoot{
	print "</form>\n";
}

1; #return true